#pragma strict

var velocity : Vector3;
var gravity : float;
var impact_sound : AudioClip;
var impact_particles : GameObject;
var shadow : GameObject;
var makes_impact_sound : boolean;
private var shadow_object : GameObject;

function SetVelocity( _velocity ){
	velocity = _velocity;
	//GetComponent(Rigidbody).velocity = velocity;
}

function GetShadowPos() {
	var pos = transform.position;
	pos.z = -0.01;
	return pos;
}

function Start () {
	shadow_object = Instantiate(shadow, GetShadowPos(), Quaternion.AngleAxis(-90,Vector3(1,0,0))); 
}

function Explode() {
	if(makes_impact_sound){
		AudioSource.PlayClipAtPoint(impact_sound, transform.position, 2.0);
	}
	Instantiate(impact_particles, transform.position + Vector3(0,0,-0.1), Quaternion.identity);
	Destroy(shadow_object);
	Destroy(gameObject);
}

function FixedUpdate () {
	var hit_info : RaycastHit;
	var hit_something = Physics.Raycast(transform.position, velocity.normalized, hit_info, velocity.magnitude * Time.deltaTime);
	if(hit_something){
		if(hit_info.collider.gameObject.CompareTag("TrainCar")){
			hit_info.collider.gameObject.GetComponent(CarScript).ApplyForceAtPoint(velocity, hit_info.point);
			hit_info.collider.gameObject.GetComponent(CarScript).Damage(0.1);
		}
		transform.position = hit_info.point;
		Explode();
	}
	transform.position += velocity * Time.deltaTime;
	velocity.z += gravity * Time.deltaTime;
	shadow_object.transform.position = GetShadowPos();
	shadow_object.GetComponent(Renderer).material.color.a = Mathf.Min(0.5,0.5+transform.position.z*0.6);
	if(transform.position.z >= 0.02){
		Explode();
	}
}