#pragma strict

var muzzleflash : GameObject;
var cannonballprefab : GameObject;
var cannon_speed = 5.0;
var vehicle_width = 0.4;
var shot_sound : AudioClip;
var shot_cooldown = 0.5;
private var cur_shot_cooldown = 0.0;
var gun_slots = new Array();

function Start () {
}

function AddGun ( position : Vector3 ) {
	gun_slots.Push(position);
}

function FireCannonBall(position : Vector3, direction : Vector3, _makes_impact_sound : boolean){
	var velocity = gameObject.GetComponent(CarScript).velocity +
				   gameObject.GetComponent(CarScript).drive_velocity;
	var cannonball = Instantiate(cannonballprefab, position, Quaternion.identity); 
	cannonball.GetComponent(CannonBallScript).SetVelocity(direction * cannon_speed * Random.Range(0.9,1.1) + velocity);
	cannonball.GetComponent(CannonBallScript).makes_impact_sound = _makes_impact_sound;
	Instantiate(muzzleflash, position, Quaternion.identity);
}

function FireBattery( fire_right : boolean ) : float {
	if(cur_shot_cooldown > 0.0){
		return;
	}
	var position = gameObject.GetComponent(CarScript).position;
	var rotation = gameObject.GetComponent(CarScript).rotation;
	var front = rotation * Vector3(1.0,0.0,0.0);
	var side = rotation * Vector3(0.0,1.0,0.0);
	if(fire_right){
		side *= -1.0;
	}
	var gun_slot_array : Vector3[] = gun_slots.ToBuiltin(Vector3);
	for( var i=0; i<gun_slots.length; ++i ){
		FireCannonBall(position + rotation * gun_slot_array[i] + side * vehicle_width, side, i==gun_slots.length/2);
	}
	AudioSource.PlayClipAtPoint(shot_sound, position, 1.0);
	cur_shot_cooldown = shot_cooldown;
	var tilt_mod = 50.0;
	if(!fire_right){
		tilt_mod *= -1.0;
	}
	return tilt_mod;
}

function FixedUpdate () {
	cur_shot_cooldown = Mathf.Max(0.0, cur_shot_cooldown - Time.deltaTime);
}