#pragma strict

var bad_guy_object:GameObject;
var steam_engine_object:GameObject;
var steam_car_object:GameObject;
var bad_guys = new Array();
var bad_guy_cluster_size = 10.0;
var cars = new Array();
var HUD_layer:GameObject;
var HUD_crewfire_layer:GameObject;
var HUD_crewfire_dead_layer:GameObject;
var HUD_crewko_dead_layer:GameObject;
var HUD_crew_cringe_layer:GameObject; 
var HUD_dial_layer:GameObject;
var HUD_fire_layer:GameObject;
var HUD_indicator_layer:GameObject;
var title_background:GameObject;
var title_elements:GameObject;
var title_text:GameObject;
var blackout_prefab:GameObject;
var gameover_sound:AudioClip;    
var victory_sound:AudioClip;   
var indicator_frame_one:Texture;
var indicator_frame_two:Texture; 
var dial_zero:Texture; 
var dial_one:Texture;
var dial_two:Texture;
var dial_three:Texture;
var dial_four:Texture;
private var title_bg_color = 0.0;
private var title_el_color = 0.0;
private var title_text_alpha = 0.0;
private var title_fade = 1.0;
private var blackout_object:GameObject;
private var title_background_object:GameObject;
private var title_elements_object:GameObject;
private var title_text_object:GameObject;
private var HUD_object:GameObject;
private var HUD_crewfire_object:GameObject;
private var HUD_crewfire_dead_object:GameObject;
private var HUD_crewko_dead_object:GameObject;
private var HUD_crew_cringe_object:GameObject;
private var HUD_indicator_object:GameObject; 
private var HUD_dial_object_one:GameObject; 
private var HUD_dial_object_two:GameObject;
private var HUD_dial_object_three:GameObject;
private var HUD_fire_object:GameObject;
private var soundtrack_volume = 0.0;
private var _title_mode = 0;
private var _game_mode = 1;
private var mode = _title_mode;
private var fade_out = 0.0;
private var game_over = false;
private var camera_angle_z = 90.0;
private var camera_angle_x = -70.0;
private var camera_distance = 5.0;
private var camera_mode_switch = 0.0; 
private var old_camera_mode = 0;
private var death_type = 0;
private var death_layer = 0.0;
private var hud_heat = 0.0;
private var cam_type = 2;
private var cringe_time = 0.0; 
private var paused = false;
private var slomo = false; 
private var victory_music_duck = 0.0;
var spawn_how_many_bad_guys = 5; 

function SpawnBadGuys() {
	var player = GameObject.Find("Player");
	for(var i = 0; i < spawn_how_many_bad_guys; ++i){
		var pos = player.transform.position + Quaternion.AngleAxis(Random.Range(0.0,360.0), Vector3(0.0,0.0,1.0)) *
			Vector3(Random.Range(5.0,5.0+spawn_how_many_bad_guys),0.0,0.0);
		var bad_guy = Instantiate(bad_guy_object, pos, Quaternion.identity);
		bad_guy.GetComponent(RoboBugScript).target = player;
		bad_guys.Push(bad_guy);
	}
	if(spawn_how_many_bad_guys % 10 == 0){
		for(i = 0; i < spawn_how_many_bad_guys / 10; ++i){
			var enemy = Instantiate(steam_engine_object, Vector3(Random.Range(-5.0,5.0),Random.Range(-5.0,5.0),-0.2), Quaternion.identity);
			enemy.name = "Enemy";
			enemy.transform.rotation.SetEulerAngles(-90,0,0);
			enemy.GetComponent(CarScript).target = player;  
			pos = player.transform.position + Quaternion.AngleAxis(Random.Range(0.0,360.0), Vector3(0.0,0.0,1.0)) *
					Vector3(Random.Range(spawn_how_many_bad_guys,spawn_how_many_bad_guys*2),0.0,0.0);
			enemy.transform.position = pos;
			cars.Push(enemy); 
		}
	}  
	spawn_how_many_bad_guys += 5;
}

function StartTitle () {
	mode = _title_mode;
	title_background_object = Instantiate(title_background);
	title_elements_object = Instantiate(title_elements);
	title_text_object = Instantiate(title_text);
	title_fade = 0.0;
}

function GetCars() : Array {
	return cars;
}

function FindClosestCar( point : Vector3 ) : GameObject {
	var car_array : GameObject[] = cars.ToBuiltin(GameObject);
	var closest_so_far : GameObject;
	var closest_distance : float;
	for( var car : GameObject in car_array ){
		var car_script = car.GetComponent(CarScript);
		if(car_script.is_engine || car_script.destroyed || car_script.next_car){
			continue;
		}
		var dist = (point - car.transform.position).sqrMagnitude;
		if(!closest_so_far || dist < closest_distance){
			closest_distance = dist;
			closest_so_far = car;
		}
	}
	return closest_so_far;
}
 
function UpdateDial( which : int , val : float ) {   
	var object : GameObject;
	switch(which){
		case 0: 
			if(!HUD_dial_object_one){HUD_dial_object_one = Instantiate(HUD_dial_layer);}  
			object = HUD_dial_object_one; break;
		case 1: 
			if(!HUD_dial_object_two){HUD_dial_object_two = Instantiate(HUD_dial_layer);}  
			object = HUD_dial_object_two; object.transform.position.y = 0.064; break;
		case 2: 
			if(!HUD_dial_object_three){HUD_dial_object_three = Instantiate(HUD_dial_layer);}  
			object = HUD_dial_object_three; object.transform.position.y = 0.064; object.transform.position.x = 0.732; break;
	 }
	var dial_val = Mathf.FloorToInt(val * 16.0) % 16; 
	var gtc = object.GetComponent(GUITexture);
	switch(dial_val){  
		case 0: gtc.texture = dial_zero; gtc.pixelInset = Rect(0,0,128,56); break; 
		case 1: gtc.texture = dial_one; gtc.pixelInset = Rect(0,0,128,56); break;
		case 2: gtc.texture = dial_two; gtc.pixelInset = Rect(0,0,128,56); break;
		case 3: gtc.texture = dial_three; gtc.pixelInset = Rect(0,0,128,56); break;
		case 4: gtc.texture = dial_four; gtc.pixelInset = Rect(0,0,128,56); break; 
		case 5: gtc.texture = dial_three; gtc.pixelInset = Rect(0,110,128,-184); break; 
		case 6: gtc.texture = dial_two; gtc.pixelInset = Rect(0,110,128,-184); break;
		case 7: gtc.texture = dial_one; gtc.pixelInset = Rect(0,110,128,-184); break; 
		case 8: gtc.texture = dial_zero; gtc.pixelInset = Rect(0,110,128,-184); break;  
		case 9: gtc.texture = dial_one; gtc.pixelInset = Rect(128,110,-128,-184); break;
		case 10: gtc.texture = dial_two; gtc.pixelInset = Rect(128,110,-128,-184); break;
		case 11: gtc.texture = dial_three; gtc.pixelInset = Rect(128,110,-128,-184); break;
		case 12: gtc.texture = dial_four; gtc.pixelInset = Rect(128,0,-128,56); break; 
		case 13: gtc.texture = dial_three; gtc.pixelInset = Rect(128,0,-128,56); break; 
		case 14: gtc.texture = dial_two; gtc.pixelInset = Rect(128,0,-128,56); break;
		case 15: gtc.texture = dial_one; gtc.pixelInset = Rect(128,0,-128,56); break; 
	}
}

function UpdateIndicator() {
	var center = Vector3(0.4,0.7,0.0);
	var up_left = Vector3(0.055,0.945,0.0);
	var bottom_right = Vector3(0.75,0.33,0.0);
	
	var car = FindClosestCar((cars[0] as GameObject).transform.position);
	if(!car){
		if(HUD_indicator_object){
			Destroy(HUD_indicator_object);
		}
		return;
	}
	
	var world_pos = car.transform.position;
	var cam = GameObject.Find("Game Camera");
	var relativePosition = cam.transform.InverseTransformPoint(world_pos);
    var offset = Vector3(-0.08,0.11,0.0);
    var indicator_pos = cam.GetComponent(Camera).WorldToViewportPoint(cam.transform.TransformPoint(relativePosition)) + offset;
    var offscreen = false;
    if(indicator_pos.x > bottom_right.x || 
       indicator_pos.x < up_left.x || 
       indicator_pos.y < bottom_right.y || 
       indicator_pos.y > up_left.y)
    {
    	offscreen = true;
    }
    indicator_pos = Vector3(Mathf.Clamp(indicator_pos.x, up_left.x, bottom_right.x),
                            Mathf.Clamp(indicator_pos.y, bottom_right.y, up_left.y),
                            0);
	if(offscreen){
		if(!HUD_indicator_object){
			HUD_indicator_object = Instantiate(HUD_indicator_layer);
		}
		HUD_indicator_object.transform.position = indicator_pos; 
		if(Mathf.Sin(Time.time*4.0) > 0.0){
			HUD_indicator_object.GetComponent(GUITexture).texture = indicator_frame_two;
		} else { 
			HUD_indicator_object.GetComponent(GUITexture).texture = indicator_frame_one;
		}
	} else {
		if(HUD_indicator_object){
			Destroy(HUD_indicator_object);
		}
	}
}

function StartGame () {
	for(var bad_guy : GameObject in bad_guys) {
		bad_guy.GetComponent(RoboBugScript).Remove();
	}
	bad_guys.clear();
	for(var car : GameObject in cars) {
		car.GetComponent(CarScript).Remove();
	}
	cars.clear();
	game_over = false;
	spawn_how_many_bad_guys = 5;
	mode = _game_mode;
	if(!HUD_object){
		HUD_object = Instantiate(HUD_layer);
	}
	var player = Instantiate(steam_engine_object, Vector3(Random.Range(-5.0,5.0),Random.Range(-5.0,5.0),-0.2), Quaternion.identity);
	player.name = "Player";
	player.transform.rotation.SetEulerAngles(-90,0,0);
	player.GetComponent(CarScript).player_controlled = true;
	cars.Push(player);
	var car = Instantiate(steam_car_object, player.transform.position + Vector3(-1.7,1.5,0), Quaternion.identity);
	car.name = "Car";
	car.transform.rotation.SetEulerAngles(-90,0,0);
	cars.Push(car);
	var car2 = Instantiate(steam_car_object, player.transform.position + Vector3(-4.0,-3,0), Quaternion.identity);
	car2.name = "Car2";
	car2.transform.rotation.SetEulerAngles(-90,0,0);
	cars.Push(car2);
}

function Start () {
	StartTitle();
	//StartGame();
}
 
 function FindClosestEnemy(point:Vector3){
	var car_array : GameObject[] = cars.ToBuiltin(GameObject);
	var closest_so_far : GameObject;
	var closest_distance : float;
	for( var car : GameObject in car_array ){
		var car_script = car.GetComponent(CarScript);
		if(!car_script.is_engine || car_script.destroyed || car_script.player_controlled){
			continue;
		}
		var dist = (point - car.transform.position).sqrMagnitude;
		if(!closest_so_far || dist < closest_distance){
			closest_distance = dist;
			closest_so_far = car;
		}
	} 
	return closest_so_far;
 }
 
function FixedUpdate () {
	if(!game_over && victory_music_duck == 0.0){
		soundtrack_volume = Mathf.MoveTowards(soundtrack_volume, 1.0, Time.deltaTime * 0.2);
	} else {
		soundtrack_volume = Mathf.MoveTowards(soundtrack_volume, 0.0, Time.deltaTime * 0.3);
	} 
	victory_music_duck = Mathf.Max(0.0, victory_music_duck - Time.deltaTime); 
	
	if(mode == _game_mode){
		var cam = GameObject.Find("Game Camera");
		var train = GameObject.Find("Player");
		
		if(cam_type == 0){
			cam.transform.position = train.transform.position;
			cam.transform.forward = Vector3(0,0.4,1);
			camera_distance = 6;
			cam.transform.position += cam.transform.forward * -camera_distance;
		} else if(cam_type == 1){
			cam.transform.position = train.transform.position;
			camera_angle_z += Input.GetAxis("Mouse X");
			camera_angle_x += Input.GetAxis("Mouse Y");
			camera_angle_x = Mathf.Min(camera_angle_x, -32);
			cam.transform.position += Quaternion.AngleAxis(camera_angle_z,Vector3(0,0,1)) * Quaternion.AngleAxis(camera_angle_x,Vector3(0,1,0)) * Vector3(-3,0,0) +
									  Vector3(0,0,-0.2);
			cam.transform.LookAt(train.transform.position+Vector3(0,0,-0.2), Vector3(0,0,-1));
		} else if(cam_type == 2){  
			cam.transform.position = train.transform.position; 			
			var enemy = FindClosestEnemy(train.transform.position);  
			if(enemy){
				if(old_camera_mode == 0){
					old_camera_mode = 1;
					camera_mode_switch = 1.0;
				}
			} else { 
				if(old_camera_mode == 1){
					old_camera_mode = 0;
					camera_mode_switch = 1.0;
				}
			}
			if(enemy){
				var dir = (enemy.transform.position - train.transform.position).normalized; 
				var target_camera_angle_z = Mathf.Atan2(dir.y, dir.x) * 180.0 / Mathf.PI; 
				while(camera_angle_z > target_camera_angle_z + 180.0){ 
					camera_angle_z -= 360.0;
				}
				while(camera_angle_z < target_camera_angle_z - 180.0){ 
					camera_angle_z += 360.0;
				}
				camera_angle_z = Mathf.Lerp(target_camera_angle_z, camera_angle_z, Mathf.Pow(0.3+0.7*camera_mode_switch,Time.deltaTime)); 
				camera_angle_x = Mathf.Lerp(35, camera_angle_x, Mathf.Pow(0.3+0.7*camera_mode_switch,Time.deltaTime));
				camera_distance = Mathf.Lerp(3.0, camera_distance, Mathf.Pow(0.3+0.7*camera_mode_switch,Time.deltaTime)); 
			} else {
				camera_angle_z = Mathf.Lerp(90.0, camera_angle_z, Mathf.Pow(0.3+0.7*camera_mode_switch,Time.deltaTime)); 
				camera_angle_x = Mathf.Lerp(-70, camera_angle_x, Mathf.Pow(0.3+0.7*camera_mode_switch,Time.deltaTime));
				camera_distance = Mathf.Lerp(5.0, camera_distance, Mathf.Pow(0.3+0.7*camera_mode_switch,Time.deltaTime)); 
			}
			camera_angle_x = Mathf.Min(camera_angle_x, -32);
			cam.transform.position += Quaternion.AngleAxis(camera_angle_z,Vector3(0,0,1)) * Quaternion.AngleAxis(camera_angle_x,Vector3(0,1,0)) * Vector3(-3,0,0);
			cam.transform.position = (cam.transform.position - train.transform.position).normalized * camera_distance + train.transform.position;
			cam.transform.position += Vector3(0,0,-0.2);
			cam.transform.LookAt(train.transform.position+Vector3(0,0,-0.2), Vector3(0,0,-1));  
			camera_mode_switch = Mathf.Max(0.0, camera_mode_switch - Time.deltaTime);
		} 
	}
}

function UpdateHUDHeat(heat : float) { 
	if(!game_over){	
		hud_heat = heat; 
	}
}

function UpdateHUDDamaged() {
	cringe_time = 0.2;
}

function UpdateHUD() {
	UpdateIndicator(); 
	var player = GameObject.Find("Player");  
	if(player){
		var player_script = player.GetComponent(CarScript);
		if(player_script){
			UpdateDial(0,(player_script.velocity + player_script.drive_velocity).magnitude / 4.5); 
			UpdateDial(1,player_script.heat);  
			UpdateDial(2,player_script.damage); 
		}
	}
	if(hud_heat>0.7){
		if(!HUD_crewfire_object){
			HUD_crewfire_object = Instantiate(HUD_crewfire_layer);
		}
		HUD_crewfire_object.GetComponent(GUITexture).color.a = Mathf.Min(1.0,(hud_heat - 0.7)/0.2);
	} else {
		if(HUD_crewfire_object){
			Destroy(HUD_crewfire_object);
		}
	}
	if(hud_heat < 0.7 && cringe_time > 0.0 && !game_over){
		if(!HUD_crew_cringe_object){
			HUD_crew_cringe_object = Instantiate(HUD_crew_cringe_layer);
		}
	} else {
		if(HUD_crew_cringe_object){
			Destroy(HUD_crew_cringe_object);
		}
	}	
	if(hud_heat>0.4){
		if(!HUD_fire_object){
			HUD_fire_object = Instantiate(HUD_fire_layer);
		}
		HUD_fire_object.GetComponent(GUITexture).color.a = Mathf.Min(1.0,(hud_heat - 0.4)/0.2);
	} else {
		if(HUD_fire_object){
			Destroy(HUD_fire_object);
		}
	}
	var death_fade = Mathf.Max(0.0, Mathf.Min(1.0, 2.0 - fade_out * 2.0))*0.5;
	cringe_time = Mathf.Max(0.0, cringe_time - Time.deltaTime);
	if(game_over){
		hud_heat = Mathf.Max(0.0,hud_heat - Time.deltaTime);
	}
	if(game_over && death_type == 0){
		if(!HUD_crewfire_dead_object){
			HUD_crewfire_dead_object = Instantiate(HUD_crewfire_dead_layer);
		}
		HUD_crewfire_dead_object.GetComponent(GUITexture).color.r = death_fade;
		HUD_crewfire_dead_object.GetComponent(GUITexture).color.g = death_fade;
		HUD_crewfire_dead_object.GetComponent(GUITexture).color.b = death_fade;
		
	} else {
		if(HUD_crewfire_dead_object){
			Destroy(HUD_crewfire_dead_object);
		}
	}
	if(game_over && death_type == 1){
		if(!HUD_crewko_dead_object){
			HUD_crewko_dead_object = Instantiate(HUD_crewko_dead_layer);
		}
		HUD_crewko_dead_object.GetComponent(GUITexture).color.r = death_fade;
		HUD_crewko_dead_object.GetComponent(GUITexture).color.g = death_fade;
		HUD_crewko_dead_object.GetComponent(GUITexture).color.b = death_fade;
	} else {
		if(HUD_crewko_dead_object){
			Destroy(HUD_crewko_dead_object);
		}
	}
	
}

function UpdateGame () {
	if(bad_guys.length == 0){
		SpawnBadGuys();
	}
	if(Input.GetKeyDown("tab")){ 
		slomo = !slomo;
		if(!paused){
			if(slomo){
				Time.timeScale = 0.1;
			} else {
				Time.timeScale = 1.0;
			}
		}
	}
	if(Input.GetKeyDown("1")){
		cam_type = 0;
	} 
	if(Input.GetKeyDown("2")){
		cam_type = 1;
	}
	if(Input.GetKeyDown("3")){
		cam_type = 2;
	}
	if(title_fade < 1.0){
		title_background_object.GetComponent(GUITexture).color.a = 1.0-title_fade;
		title_elements_object.GetComponent(GUITexture).color.a = 1.0-title_fade;
		title_text_object.GetComponent(GUITexture).color.a = 1.0-title_fade;
		title_fade = Mathf.Lerp(title_fade, 1.0, Time.deltaTime * 5.0);
		if(title_fade >= 1.0){
			Destroy(title_background_object);
			Destroy(title_elements_object);
			Destroy(title_text_object);
		}
	}
	if(game_over){
		fade_out = Mathf.Min(1.0, fade_out + Time.deltaTime * 0.27);
		if(!blackout_object){
			blackout_object = Instantiate(blackout_prefab);
		}
		blackout_object.GetComponent(GUITexture).color.a = fade_out;
		if(fade_out == 1.0){
			StartGame();
		}
	} else {
		fade_out = Mathf.Max(0.0, fade_out - Time.deltaTime);
		if(fade_out == 0.0){
			Destroy(blackout_object);
		}
		if(blackout_object){				
			blackout_object.GetComponent(GUITexture).color.a = fade_out;
		}
	}
	UpdateHUD();
	
    if(Input.GetKeyDown("escape"))
    {  
		paused = !paused; 
    	if(!paused){	 
    		if(slomo){
    			Time.timeScale = 0.1; 
			} else {
				Time.timeScale = 1.0;
			}
		} else {
			Time.timeScale = 0.0;
		} 
    }
}

function UpdateTitle () {
	title_background_object.GetComponent(GUITexture).color.r = title_bg_color;
	title_background_object.GetComponent(GUITexture).color.g = title_bg_color;
	title_background_object.GetComponent(GUITexture).color.b = title_bg_color;
	title_elements_object.GetComponent(GUITexture).color.r = title_el_color;
	title_elements_object.GetComponent(GUITexture).color.g = title_el_color;
	title_elements_object.GetComponent(GUITexture).color.b = title_el_color;
	title_text_object.GetComponent(GUITexture).color.a = title_text_alpha;
	title_bg_color = Mathf.Lerp(title_bg_color, 1.0, Time.deltaTime);
	if(title_bg_color > 0.8){
		title_el_color = Mathf.Lerp(title_el_color, 1.0, Time.deltaTime * 0.5);
	}
	if(title_el_color > 0.65){
		title_text_alpha = Mathf.Lerp(title_text_alpha, 1.0, Time.deltaTime * 0.5);
	}
	if(title_text_alpha > 0.9){
		StartGame();
	}	
}

function PlayerDied(how : int) {
	if(!game_over){
		game_over = true;
		death_type = how;
		AudioSource.PlayClipAtPoint(gameover_sound, GameObject.Find("Game Camera").transform.position);
	}
}  

function EnemyDied() { 
	if(!FindClosestEnemy(Vector3(0.0,0.0,0.0))){
		AudioSource.PlayClipAtPoint(victory_sound, GameObject.Find("Game Camera").transform.position);
		victory_music_duck = 12;  
	}
} 

function Update () {
	if(mode == _game_mode){
		UpdateGame();
	}
	if(mode == _title_mode){
		UpdateTitle();
	}
	GameObject.Find("Main Camera").GetComponent(AudioSource).volume = soundtrack_volume;
}

function BadGuyDied (the_guy : GameObject) {
	for(var i=0; i<bad_guys.length; ++i){
		if(bad_guys[i] == the_guy){
			bad_guys.RemoveAt(i);
			break;
		}
	}
}